﻿#include <oxstd.h>
#include <oxprob.h>
#include <oxgauss.h>

/*random variables following inverse Wishart distribution*/
invwish(const nyu, const DAT){
decl gyo, kazu, rm2, zer, rm22, nn, IRV, RV2;

  gyo = rows(DAT);
  kazu = nyu-gyo-1;
  
  rm2 = ones(1,gyo);
  zer = zeros(gyo,1);
  rm22 = zeros(gyo,gyo);

  for(nn=0; nn<kazu; ++nn){
    rm2 = zer + choleski(DAT)*rann(gyo,1);
    rm22 = rm22 + rm2*rm2';
  }

  IRV = rm22;
  RV2=invert(IRV);
  return(RV2);
}

main()
{
  decl N, T, TT, TI, P, B, C, J, M, BT, BTI, CT, CTI, BS, AS, BSI, ASI, BM, AM, BBM, AAM, Q, H, R, EP,
       SS, S, MITC;
  decl YD, YDI, YY, YYI, YYIT, YC, YCI, YCIT, YB, YBI, YBIT, YYB, YYBI, YYBIT, XSC, XSCI, XC, XCI, XCIT, XXCIT, XB, XBI, XI,
       XBIT, XXBIT, XIT, XXIT, XITB, XBITB;
  decl ZZ, ZI, ZIT, ZBO, ZBC, WW, WI, WIT, SSETI, YCNUM, VS, VSI, VV, VVI, VVIT, VIT, UU, UUI, UUIT, VU, VUI, VUIT,
       VSU, VSUI, VSUIT, TEM, MUV, MUU, MUVU;
  decl AL, GA, BE, PH, GAI, BEI, ALI, TH, VB1, VB11, VB12, VB2, VB21, VB22, VB22_1, VB22_2, VB22_3, VB22_4, VB, VG, VG2, PS,
       VET, ET, SIG, SIGU, SIGL, SIG2, SIGB, RHO, LAM, LAM2;
  decl i, j, w, b, c, d, ds, bs, ru, u, s, ku, a, v, mm, mmo;
  decl DI, DDI, CI, IIC, II, IIB, DE, MUD, MAXU, UISM, S1, IIBS;
  decl TRUETH_OUT, TRUEVB_OUT, TRUEPH_OUT, TRUEVG_OUT, TRUEGA_OUT, TRUEBE_OUT, TRUEPS_OUT, TRUEVET_OUT, TRUEET_OUT,
       TRUESIG_OUT, TRUERHO_OUT, TRUELAM_OUT;
  decl YYDATA_OUT, YCDATA_OUT, YBDATA_OUT, YDDATA_OUT, VVDATA_OUT, VSDATA_OUT, UUDATA_OUT, VUDATA_OUT, VSUDATA_OUT,
	   TTDATA_OUT, SSDATA_OUT, XCDATA_OUT, XSCDATA_OUT, XBDATA_OUT, ZZDATA_OUT, WWDATA_OUT;

  decl THDATA, VBDATA, PHDATA, VGDATA, BEDATA, GADATA, LAMDATA, SIGDATA, THDATA_OUT, VBDATA_OUT, PHDATA_OUT, VGDATA_OUT,
       BEDATA_OUT, GADATA_OUT, LAMDATA_OUT, SIGDATA_OUT;
	   
  decl TBE_OUT, TLAM_OUT;
  
  decl BURN, KAI, NUM;
  decl KAI_OUT, TTH_OUT, TVB_OUT, TPH_OUT, TVG_OUT, TSIG_OUT;
  decl PRMT, PRVT;
  decl TGA_OUT, TRHO_OUT, TPS_OUT;
  decl PS2;
  
  decl ZZ1, ZZ2, ZZ1DATA_OUT, ZZ2DATA_OUT, SUM, SEED; 

// ∑
  decl VULW, IRN, DD, N0P, P0P, NNP, PN, IPN;
// Λ
  decl GB, AG, OM, OMI, UL, UIM, OR, UR, HATG, TILLG, TILG, SUUA, GAMMA, M0T, V0T;
//β
  decl M0B, V0B, OIT,  SIGT, MGI, VGI, BL, BBL, XIX, XIK, VBL, MBL, MBI, VBI;
// θ
  decl MT0, VT0, VTH, BBE, MTH, NL, MTL0, STL0;
// φ
  decl MPL0, SPL0, MP0, VP0, VPH, GGA, MPH;
// Vβ
  decl SB0, RB0, NNB, PSNB, IPSNB;
  decl SBL0, RBL0, SBNL, RBNL, LK, TTHL, BTL, IRBNL;
// Vγ
  decl SG0, RG0, NNG, PSNG, IPSNG;
  decl SGL0, RGL0, SGNL, RGNL, PPHL, GTL, IRGNL;
//γ_i
  decl M0G, V0G, MG, SI, BXI, PSS, VGL, MGL, LVEC, LKI, TM, CTCM, LKIS, BKI, EGS, PSSL;
// v and u
  decl MU, ISIG, SBB, SB, UC, MUC, GG, TBV, TB, MIC, FF0, FUF, VIBS, SYB, UIBS, UUC, MAU, LLAM,
       TBKI, SSIG, LS, ILS, MUT, UPR, UPO, XBIO;
	   
  format(30000);

ranseed(12345);

N = 1000;  /*number of consumers*/
B = 3;  /*number of brands*/
C = B + 1;

BURN = 1000;   /*Burn-in*/
KAI = 10000;   /*MCMC iteration*/
NUM = KAI - BURN;

M = 1;
BM = B*M;
BBM = B*B*M;

J = 5;  /*the number of the explanatory variables for product category purchase*/

Q = B + 3;  /*the number of the explanatory variables for multiple brand purchase*/

P = J + Q;


T = 20;  /*the number of purchase occasions*/
BT = B*T;
CT = C*T;


//////////////////////////////  input the calibration data ///////////////////////////////////


/*Data containing the number of purchase occasions*/
TT = zeros(N,1);  
TTDATA_OUT = fopen("(file path)\TTDATA_CALIBRATION.txt");
fscan(TTDATA_OUT,"%#m",N,1,&TT);
fclose(TTDATA_OUT);

/*Explanatory variables for brand purchase*/
XB = zeros(N*Q,BT);  
XBDATA_OUT = fopen("(file path)\XBDATA_CALIBRATION.txt");
fscan(XBDATA_OUT,"%#m",N*Q,BT,&XB);
fclose(XBDATA_OUT);

/*Explanatory variable matrices for category purchase*/
XC = zeros(N,J*T);
XCDATA_OUT = fopen("(file path)\XCDATA_CALIBRATION.txt");
fscan(XCDATA_OUT,"%#m",N,J*T,&XC);
fclose(XCDATA_OUT);

ZZ = zeros(N*CT,P);

for(i=0; i<N; ++i){
  TI = TT[i];
  XCI = XC[i][]';
  
  XBI = XB[i*Q:(i+1)*Q-1][0:BT-1]'; //  BT × Q

  ZI = zeros(CT,P);

  for(u=0; u<TI; ++u){
    XCIT = XCI[u*J:(u+1)*J-1][];
	XCIT = XCIT' ~ zeros(1,Q); /* (x'_it  0') */
    
    XBIT = XBI[u*B:(u+1)*B-1][];
	XBIT = zeros(B,J) ~ XBIT; /* ( O  W_it ) */
	
	ZIT = XCIT | XBIT;

  ZI[u*C:(u+1)*C-1][] = ZIT;
  }  /*u*/

ZZ[i*CT:(i+1)*CT-1][] = ZI;
}  /*i*/


YY = zeros(N,CT);	 /*Data containing both category and brand purchases*/
YYDATA_OUT = fopen("(file path)\YYDATA_CALIBRATION.txt");
fscan(YYDATA_OUT,"%#m",N,CT,&YY);
fclose(YYDATA_OUT);

YC = zeros(N,T);   /*Data containing only category purchases*/
YCDATA_OUT = fopen("(file path)\YCDATA_CALIBRATION.txt");
fscan(YCDATA_OUT,"%#m",N,T,&YC);
fclose(YCDATA_OUT);

YB = zeros(N,BT);  /*Data containing only brand purchases*/
YBDATA_OUT = fopen("(file path)\YBDATA_CALIBRATION.txt");
fscan(YBDATA_OUT,"%#m",N,BT,&YB);
fclose(YBDATA_OUT);


/////////////////////////////////////////////////////

               /*Starting parameter estimation*/

/////////////////////////////////////////////////////


SUM = zeros(C,1);

VU = zeros(N,CT);  /*A matrix that combines the category and brand latent utilities*/
VV = zeros(N,T);   /*category latent utility matrix*/
UU = zeros(N,BT);  /*brand latent utility matrix*/

/*initial values*/
TH = zeros(J,1);
VB = unit(J);
PH = zeros(Q,1);
VG = unit(Q);
LAM = zeros(B,BM);
SIG = unit(C);


BE = zeros(N,J);
GA = zeros(N,Q);

BE = zeros(N,J);
for(i=0; i<N; ++i){
  BEI = zeros(J,1);
  BEI = TH + choleski(VB)*rann(J,1);

BE[i][] = BEI';
}


GA = zeros(N,Q);
for(i=0; i<N; ++i){
  GAI = zeros(Q,1);
  GAI = PH + choleski(VG)*rann(Q,1);

GA[i][] = GAI';
}

RHO = SIG[1:C-1][0];
PS = SIG[1:C-1][1:C-1] - RHO*RHO';


/*prior distributions*/

// θ
MTL0 = zeros(J,1);
STL0 = 10000*unit(J);

// V_β
SBL0 = J + 1;
RBL0 = SBL0*unit(J);

// φ
MPL0 = zeros(Q,1);
SPL0 = 10000*unit(Q);

// V_γ
SGL0 = Q + 1;
RGL0 = SGL0*unit(Q);

// Σ
N0P = C + 1;
P0P = N0P*unit(C);

// Λ
GB = zeros(BM,B);
AG = 0.01*unit(BM);

/*Matrices containing the results of MCMC iteration*/
THDATA = zeros(1,J);
VBDATA = zeros(1,J*J);
PHDATA = zeros(1,Q);
VGDATA = zeros(1,Q*Q);
SIGDATA = zeros(1,C*C);
LAMDATA = zeros(1,B*BM);


IIC = zeros(C*C,C-1);
for(d=0; d<C; ++d){

  II = zeros(C,C-1);
  for(ds=0; ds<C; ++ds){
    if (ds < d){
      II[ds][ds] = 1;
    }
    if (ds > d){
      II[ds][ds-1] = 1;
    }
  }

IIC[d*C:(d+1)*C-1][] = II;
}


IIB = zeros(B*B,B-1);
for(d=0; d<B; ++d){

  II = zeros(B,B-1);
  for(ds=0; ds<B; ++ds){
    if (ds < d){
      II[ds][ds] = 1;
    }
    if (ds > d){
      II[ds][ds-1] = 1;
    }
  }

IIB[d*B:(d+1)*B-1][] = II;
}

LLAM = zeros(C,C);


for (mm=1; mm<KAI+1; ++mm){


//////////////////  generate v  ///////////////////////////


for(i=0; i<N; ++i){
  TI = TT[i][0];
  BTI = B*TI;
  CTI = C*TI;
  
  BEI = BE[i][]';
  GAI = GA[i][]';
  ALI = BEI | GAI;

  VUI = VU[i][]';
  VVI = VV[i][]';
  UUI = UU[i][0:BTI-1]';

  ZI = ZZ[i*CT:(i+1)*CT-1][];
  ZI = ZI[0:CTI-1][]; 
  
  YYI = YY[i][]';

  for(u=0; u<TI; ++u){
    YYIT = YYI[u*C:(u+1)*C-1][];
	YCIT = YYIT[0][];
	YBIT = YYIT[1:C-1][]; 

    VUIT = VUI[u*C:(u+1)*C-1][];

	ZIT = ZI[u*C:(u+1)*C-1][];
    MU = ZIT*ALI;

	UISM = zeros(BM,1);
    a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    }
    if (a > M) {
      for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 
	  
    II = zeros(C,C-1);
    II = IIC[0:C-1][];
  
    UC = II'*VUIT;
    MUC = II'*MU;

	SIGB = SIG[1:C-1][1:C-1];
	  
    TBV = 1 - RHO'*invert(SIGB)*RHO; 
    TB = sqrt(TBV); 

    MIC = MU[0][] + RHO'*invert(SIGB)*(UC - MUC - LAM*UISM);
    MAU = (0 - MIC)/TB;
    FF0 = 0;
    FF0 = probn(MAU);

    if(YCIT == 0){
	
      ku = ranu(1,1);
	  FUF = ku*FF0;
      if(FUF==1){
        FUF = 0.9999999;
      }
      if(FUF==0){
        FUF = 10^(-317);
      }
	  VIBS = quann(FUF);
	  
	}

    if(YCIT == 1){
	  	
      ku = ranu(1,1);
	  FUF = FF0 + ku*(1-FF0);
      if(FUF==1){
        FUF = 0.9999999;
      }
      if (FUF==0){
        FUF = 10^(-317);
	  }
	  VIBS = quann(FUF);

    }
	
    VUIT[0][] = MIC + TB*VIBS;

  VUI[u*C:(u+1)*C-1][] = VUIT;
  VVI[u][] = VUIT[0][];
  }  
  
VU[i][]	= VUI';
VV[i][] = VVI';
} 



//////////////////   end of generate v  ///////////////////////////



//////////////////  generate u  ///////////////////////////



for(i=0; i<N; ++i){
  TI = TT[i][0];
  BTI = B*TI;

  BEI = BE[i][]';
  GAI = GA[i][]';
  
  VUI = VU[i][]';
  UUI = UU[i][0:BTI-1]';
  
  XBI = XB[i*Q:(i+1)*Q-1][]'; 
  XBI = XBI[0:BTI-1][];

  XCI = XC[i][0:J*TI-1]';
  XCI = shape(XCI,J,TI);
  XCI = XCI'; 
  
  YYI = YY[i][]';
  
  for(u=0; u<TI; ++u){
    YYIT = YYI[u*C:(u+1)*C-1][];
	YCIT = YYIT[0][];
    YBIT = YYIT[1:C-1][];
	
    XBIT = XBI[u*B:(u+1)*B-1][]; 

    VUIT = VUI[u*C:(u+1)*C-1][]; 
    UUIT = UUI[u*B:(u+1)*B-1][];

    if(u == 0){
	  UPR = zeros(B,1); /*brand latent utility before one lag*/
      UPO = UUI[(u+1)*B:(u+2)*B-1][]; /*brand latent utility after one lag*/
      XBIO = XBI[(u+1)*B:(u+2)*B-1][]; 

      ILS = invert(PS) + LAM'*invert(PS)*LAM;
	  LS = invert(ILS); 
	}

    if((0 < u) && (u < TI-1)){
      UPR = UUI[(u-1)*B:u*B-1][];
      UPO = UUI[(u+1)*B:(u+2)*B-1][];
      XBIO = XBI[(u+1)*B:(u+2)*B-1][];
	  
      ILS = invert(PS) + LAM'*invert(PS)*LAM;
	  LS = invert(ILS); 
	}
	
    if(u == TI-1){
      UPR = UUI[(u-1)*B:u*B-1][];
      UPO = zeros(B,1);
      XBIO = zeros(B,Q);

      ILS = invert(PS);
	  LS = invert(ILS);
	}
	
    MU = invert(PS)*XBIT*GAI + invert(PS)*LAM*UPR + LAM'*invert(PS)*UPO - LAM'*invert(PS)*XBIO*GAI;
    MU = LS*MU;
	
    if(YCIT == 0){
      UUIT = MU + choleski(LS)*rann(B,1);
      VUIT[1:C-1][0] = UUIT; 
	}

    if(YCIT == 1){
	
      SYB = sumc(YBIT);
	  
      if (SYB == 1){
        for(b=0; b<B; ++b){

          SBB = ILS[b][b];
          SB = ILS[b][];

          II = zeros(B,B-1);
          II = IIB[b*B:b*B+B-1][0:B-2];
		
          SB = SB*II;
          UC = II'*UUIT;
          MUC = II'*MU;
          GG = - invert(SBB)*SB';
          TBV = invert(SBB);  
          TB = sqrt(TBV);
          MIC = MU[b][] + GG'*(UC - MUC);
		
          UIBS = zeros(1,1);

          MAXU = max(UC);

          if (YBIT[b][0] == 1){
            MAU = (MAXU - MIC)/TB;
            FF0 = probn(MAU);
		        
            ku = ranu(1,1);
       	    FUF = FF0 + ku*(1-FF0);
    	  }

          if (YBIT[b][0] == 0){
	  
	    	if (MAXU < 0){
              MAU = (MAXU - MIC)/TB;
              FF0 = probn(MAU);         
              ku = ranu(1,1);
		      FUF = ku*FF0;
    		}

	    	if (MAXU > 0){
              MAU = (0 - MIC)/TB;
              FF0 = probn(MAU);         
              ku = ranu(1,1);
		      FUF = ku*FF0;
    		}

          }

          if (FUF==1){
	        FUF = 0.9999999999999999;
	      }
          if (FUF==0){
            FUF = 10^(-317);
    	  }

          UIBS = quann(FUF);
          UIBS = MIC + TB*UIBS;
		  
        VUIT[b+1][0] = UIBS;
		UUIT[b][0] = UIBS;
	  	}
	  }

      if (SYB >= 2){
        for(b=0; b<B; ++b){

          SBB = ILS[b][b];
          SB = ILS[b][];

          II = zeros(B,B-1);
          II = IIB[b*B:b*B+B-1][0:B-2];
		
          SB = SB*II;
          UC = II'*UUIT;
          MUC = II'*MU;
          GG = - invert(SBB)*SB';
          TBV = invert(SBB);
          TB = sqrt(TBV);
          MIC = MU[b][] + GG'*(UC - MUC);
		
          UIBS = zeros(1,1);

          MAU = (0 - MIC)/TB;
          FF0 = probn(MAU);

          if (YBIT[b][0] == 1){
            ku = ranu(1,1);
	        FUF = FF0 + ku*(1-FF0);
	      }
	  
          if (YBIT[b][0] == 0){
            ku = ranu(1,1);
	        FUF = ku*FF0;
          }
		  
          if (FUF==1){
	        FUF = 0.9999999999999999;
	      }
          if (FUF==0){
            FUF = 10^(-317);
    	  }

          UIBS = quann(FUF);
          UIBS = MIC + TB*UIBS;
		  
        VUIT[b+1][0] = UIBS;
		UUIT[b][0] = UIBS;
	  	}
	  }	

    } 

  VUI[u*C:(u+1)*C-1][] = VUIT;
  UUI[u*B:(u+1)*B-1][] = UUIT;
  }
  
VU[i][] = VUI';
UU[i][0:BTI-1] = UUI';
} 



//////////////////  end of generate u  ///////////////////////////




//////////////////  generate β  /////////////////


for(i=0; i<N; ++i){
  TI = TT[i][0];
  CTI = C*TI;
  BTI = B*TI;
  
  GAI = GA[i][]';

  VUI = VU[i][0:CTI-1]';
  VVI = VV[i][]';
  UUI = UU[i][0:BTI-1]';  

  ZI = ZZ[i*CT:(i+1)*CT-1][];
  ZI = ZI[0:CTI-1][];
  
  YYI = YY[i][]';
  
  MBI = invert(VB)*TH;
  VBI = invert(VB);
  
  UISM = zeros(BM,1);

  for(u=0; u<TI; ++u){
    YYIT = YYI[u*C:(u+1)*C-1][];
	YCIT = YYIT[0][];
	
    VVIT = VVI[u][];

	ZIT = ZI[u*C:(u+1)*C-1][];
	XCIT = ZIT[0][0:J-1]';
	XBIT = ZIT[1:C-1][J:P-1];

    a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    }
    if (a > M) {
      for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 
	  
    VUIT = VUI[u*C:(u+1)*C-1][];
    UUIT = VUIT[1:C-1][];

    XIX = XCIT*(RHO'*invert(PS)*RHO + 1)*XCIT';	  
    VBI = VBI + XIX;

    OIT = UUIT - XBIT*GAI - VVIT*RHO - LAM*UISM;
    XIK = (VVIT - RHO'*invert(PS)*OIT)*XCIT;
    MBI = MBI + XIK;

  }

  VBI = invert(VBI);
  MBI = VBI*MBI;
  
  BEI = MBI + choleski(VBI)*rann(J,1);

BE[i][] = BEI';
}


//////////////////  end of generate β  /////////////////




//////////////////  generate γ  /////////////////


for(i=0; i<N; ++i){
  TI = TT[i][0];
  BTI = B*TI;
  
  BEI = BE[i][]';

  XBI = XB[i*Q:(i+1)*Q-1][]';
  XBI = XBI[0:BTI-1][];

  XCI = XC[i][0:J*TI-1]';
  XCI = shape(XCI,J,TI);
  XCI = XCI'; 
  
  UUI = UU[i][0:BTI-1]';
  VVI = VV[i][0:TI-1]';

  LVEC = zeros(BM,B);
  for(j=0; j<M; ++j){
    LVEC[j*B:(j+1)*B-1][] = LAM[][j*B:(j+1)*B-1];
  }
  
  LKI = zeros(BTI,BTI);
  
  for(u=1; u<TI; ++u){
    v = u - 1;
    TM = zeros(TI,M);

	if((u+M) <= TI){
      TM[u:u+M-1][] = unit(M);
    }
	else{
      TM[u:TI-1][0:TI-u-1] = unit(TI-u);
    }
	
    CTCM = TM ** unit(B);
    LKIS = CTCM*LVEC;
    LKI[][v*B:(v+1)*B-1] = LKIS;	
  }
  
  BKI = unit(BTI) - LKI;

  MGI = invert(VG)*PH;
  VGI = invert(VG);
  
  BXI = BKI*UUI - (VVI - XCI*BEI) ** RHO;

  PSS = unit(TI) ** PS;
  XIX = XBI'*invert(PSS)*XBI;

  VGI = VGI + XIX;
  VGI = invert(VGI);

  XIK = XBI'*invert(PSS)*BXI;
  MGI = MGI + XIK;

  MGI = VGI*MGI;
  
  GAI = MGI + choleski(VGI)*rann(Q,1);

GA[i][] = GAI';
}


//////////////////  end of generate γ  /////////////////



//////////////// generate θ  ///////////////////////////


BBE = BE'*ones(N,1);
  
VTH = N*invert(VB) + invert(STL0);
VTH = invert(VTH);

MTH = invert(VB)*BBE + invert(STL0)*MTL0;
MTH = VTH*MTH;

TH = MTH + choleski(VTH)*rann(J,1);


////////////////  end of generate θ  ///////////////////////////



//////////////// generate Vβ  ///////////////////////////


VB = zeros(J,J);

SBNL = zeros(1,1);
RBNL = zeros(J,J);

SBNL = SBL0 + J + 1;
RBNL = invert(RBL0);
  
TTHL = ones(N,1)**(TH');
BTL = BE - TTHL;

RBNL = RBNL + BTL'*BTL;  
SBNL = SBNL + N;

IRBNL = invert(RBNL);
VB = invwish(SBNL,IRBNL);


////////////////  end of generate Vβ  ///////////////////////////




/////////////////  generate ψ  ///////////////////////////



GGA = GA'*ones(N,1);
 
VPH = N*invert(VG) + invert(SPL0);
VPH = invert(VPH);

MPH = invert(VG)*GGA + invert(SPL0)*MPL0;
MPH = VPH*MPH;

PH = MPH + choleski(VPH)*rann(Q,1);



/////////////////  end of generate ψ  ///////////////////////////




////////////////  generate Vγ  ///////////////////////////


VG = zeros(Q,Q);

SGNL = zeros(1,1);
RGNL = zeros(Q,Q);

SGNL = SGL0 + Q + 1;
RGNL = invert(RGL0);
 
PPHL = ones(N,1)**(PH');
GTL = GA - PPHL;

RGNL = RGNL + GTL'*GTL;  
SGNL = SGNL + N;

IRGNL = invert(RGNL);
VG = invwish(SGNL,IRGNL);


////////////////  end of generate Vγ  ///////////////////////////



//////////////////  generate Σ  /////////////////



NNP = N0P + C + 1;
PN = invert(P0P);

for(i=0; i<N; ++i){
  TI = TT[i][0];
  BTI = B*TI;

  BEI = BE[i][]';
  GAI = GA[i][]';
 
  VUI = VU[i][]';
  UUI = UU[i][0:BTI-1]';  

  XBI = XB[i*Q:(i+1)*Q-1][]';
  XBI = XBI[0:BTI-1][];

  XCI = XC[i][0:J*TI-1]';
  XCI = shape(XCI,J,TI);
  XCI = XCI';
  
  for(u=0; u<TI; ++u){
    XBIT = XBI[u*B:(u+1)*B-1][];
	XCIT = XCI[u][];
	XCIT = XCIT';

    VUIT = VUI[u*C:(u+1)*C-1][];

	UISM = zeros(BM,1);
	a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
	  }
	}
	if (a > M) {
	  for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 

    MUV = XCIT'*BEI;
    MUU = XBIT*GAI + LAM*UISM;
    MUVU = MUV | MUU;

    VULW = VUIT - MUVU;
	PN = PN + VULW*VULW';
  }

NNP = NNP + TI;
}

IPN = invert(PN);
SIG = invwish(NNP,IPN);

DD = diagonalize(SIG);
DD = sqrt(DD);
DD = invert(DD);
SIG = DD*SIG*DD';


SIG[1:C-1][0] = zeros(B,1);
SIG[0][1:C-1] = zeros(1,B);

RHO = SIG[1:C-1][0];
PS = SIG[1:C-1][1:C-1] - RHO*RHO';


///////////  end of generate Σ  ////////////


////////////////  generate Λ  ///////////////////////////



OM = zeros(1,B);
UL = zeros(1,BM);
  
for(i=0; i<N; ++i){
  TI = TT[i][0];
  BTI = B*TI;
  
  BEI = BE[i][]';
  GAI = GA[i][]';
 
  UUI = UU[i][0:BTI-1]';
  
  XBI = XB[i*Q:(i+1)*Q-1][]';
  XBI = XBI[0:BTI-1][];

  VVI = VV[i][0:TI-1]';
  XCI = XC[i][0:J*TI-1]';
  XCI = shape(XCI,J,TI);
  XCI = XCI';
  
  OMI = UUI - XBI*GAI - ((VVI - XCI*BEI)**RHO);
  OMI = shape(OMI,B,TI);
  OMI = OMI';
  
  UIM = zeros(BM,TI);

  for(u=0; u<TI; ++u){
    UISM = zeros(BM,1);
	
	a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
	  }
	}
	if (a > M) {
	  for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 

  UIM[][u] = UISM;
  }

  OM = OM | OMI;
  UL = UL | UIM';
}

OR = rows(OM);
OM = OM[1:OR-1][];
UR = rows(UL);
UL = UL[1:UR-1][];
UL = UL';

HATG = invert(UL*UL')*UL*OM; 
TILLG = invert(UL*UL' + AG)*(UL*UL'*HATG + AG*GB);
TILG = vec(TILLG);
SUUA = PS ** (invert(UL*UL' + AG));
  
GAMMA = zeros(BBM,1);
GAMMA = TILG + choleski(SUUA)*rann(BBM,1);
  
LAM = shape(GAMMA,BM,B);
LAM = LAM';

////////////////  end of generate Λ  ///////////////////////////


KAI_OUT = fopen("(file path)\KAI.txt","w");
fprint(KAI_OUT,"%15.5f",mm);
fclose(KAI_OUT);

TTH_OUT = fopen("(file path)\TEMTH.txt","w");
fprint(TTH_OUT,"%15.5f",TH);
fclose(TTH_OUT);

TVB_OUT = fopen("(file path)\TEMVB.txt","w");
fprint(TVB_OUT,"%15.5f",VB);
fclose(TVB_OUT);

TPH_OUT = fopen("(file path)\TEMPH.txt","w");
fprint(TPH_OUT,"%15.5f",PH);
fclose(TPH_OUT);

TVG_OUT = fopen("(file path)\TEMVG.txt","w");
fprint(TVG_OUT,"%15.5f",VG);
fclose(TVG_OUT);

TSIG_OUT = fopen("(file path)\TEMSIG.txt","w");
fprint(TSIG_OUT,"%15.5f",SIG);
fclose(TSIG_OUT);

TLAM_OUT = fopen("(file path)\TEMLAM.txt","w");
fprint(TLAM_OUT,"%15.5f",LAM);
fclose(TLAM_OUT);


//////////////////  making MCMC iteration output data   /////////////////


THDATA = THDATA | vec(TH)';
VBDATA = VBDATA | vec(VB)';
PHDATA = PHDATA | vec(PH)';
VGDATA = VGDATA | vec(VG)';

SIG2 = vec(SIG);
SIGDATA = SIGDATA | SIG2';

LAM2 = vec(LAM);
LAMDATA = LAMDATA | LAM2';



//////////////////  end of making MCMC iteration output data  /////////////////


  mmo = mm/200;
  mmo = int(mmo)*200;
  mmo = mm - mmo;
    
  if (mmo==0){

    //////////////////  outputting the results  ////////////////////////

    THDATA_OUT = fopen("(file path)\THDATA.txt","w");
    fprint(THDATA_OUT,"%15.5f",THDATA);
    fclose(THDATA_OUT);

    VBDATA_OUT = fopen("(file path)\VBDATA.txt","w");
    fprint(VBDATA_OUT,"%15.5f",VBDATA);
    fclose(VBDATA_OUT);
	
    PHDATA_OUT = fopen("(file path)\PHDATA.txt","w");
    fprint(PHDATA_OUT,"%15.5f",PHDATA);
    fclose(PHDATA_OUT);

    VGDATA_OUT = fopen("(file path)\VGDATA.txt","w");
    fprint(VGDATA_OUT,"%15.5f",VGDATA);
    fclose(VGDATA_OUT);

    SIGDATA_OUT = fopen("(file path)\SIGDATA.txt","w");
    fprint(SIGDATA_OUT,"%15.5f",SIGDATA);
    fclose(SIGDATA_OUT);
	
    LAMDATA_OUT = fopen("(file path)\LAMDATA.txt","w");
    fprint(LAMDATA_OUT,"%15.5f",LAMDATA);
    fclose(LAMDATA_OUT);


    //////////////////  end of outputting the results  ////////////////////////
	
  }


}


}
